require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ARCH_S390_ATOMIC__)) {
    eval 'sub __ARCH_S390_ATOMIC__ () {1;}' unless defined(&__ARCH_S390_ATOMIC__);
    require 'linux/compiler.ph';
    eval 'sub ATOMIC_INIT {
        my($i) = @_;
	    eval q({ ($i) });
    }' unless defined(&ATOMIC_INIT);
    if(defined(&__KERNEL__)) {
	eval 'sub __CS_LOOP {
	    my($ptr, $op_val, $op_string) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__CS_LOOP);
	eval 'sub atomic_read {
	    my($v) = @_;
    	    eval q((($v)-> &counter));
	}' unless defined(&atomic_read);
	eval 'sub atomic_set {
	    my($v,$i) = @_;
    	    eval q(((($v)-> &counter) = ($i)));
	}' unless defined(&atomic_set);
	eval 'sub atomic_add_return {
	    my($i,$v) = @_;
    	    eval q({  &__CS_LOOP($v, $i, \\"ar\\"); });
	}' unless defined(&atomic_add_return);
	eval 'sub atomic_add {
	    my($_i, $_v) = @_;
    	    eval q( &atomic_add_return($_i, $_v));
	}' unless defined(&atomic_add);
	eval 'sub atomic_add_negative {
	    my($_i, $_v) = @_;
    	    eval q(( &atomic_add_return($_i, $_v) < 0));
	}' unless defined(&atomic_add_negative);
	eval 'sub atomic_inc {
	    my($_v) = @_;
    	    eval q( &atomic_add_return(1, $_v));
	}' unless defined(&atomic_inc);
	eval 'sub atomic_inc_return {
	    my($_v) = @_;
    	    eval q( &atomic_add_return(1, $_v));
	}' unless defined(&atomic_inc_return);
	eval 'sub atomic_inc_and_test {
	    my($_v) = @_;
    	    eval q(( &atomic_add_return(1, $_v) == 0));
	}' unless defined(&atomic_inc_and_test);
	eval 'sub atomic_sub_return {
	    my($i,$v) = @_;
    	    eval q({  &__CS_LOOP($v, $i, \\"sr\\"); });
	}' unless defined(&atomic_sub_return);
	eval 'sub atomic_sub {
	    my($_i, $_v) = @_;
    	    eval q( &atomic_sub_return($_i, $_v));
	}' unless defined(&atomic_sub);
	eval 'sub atomic_sub_and_test {
	    my($_i, $_v) = @_;
    	    eval q(( &atomic_sub_return($_i, $_v) == 0));
	}' unless defined(&atomic_sub_and_test);
	eval 'sub atomic_dec {
	    my($_v) = @_;
    	    eval q( &atomic_sub_return(1, $_v));
	}' unless defined(&atomic_dec);
	eval 'sub atomic_dec_return {
	    my($_v) = @_;
    	    eval q( &atomic_sub_return(1, $_v));
	}' unless defined(&atomic_dec_return);
	eval 'sub atomic_dec_and_test {
	    my($_v) = @_;
    	    eval q(( &atomic_sub_return(1, $_v) == 0));
	}' unless defined(&atomic_dec_and_test);
	eval 'sub atomic_clear_mask {
	    my($mask,$v) = @_;
    	    eval q({  &__CS_LOOP($v, ~$mask, \\"nr\\"); });
	}' unless defined(&atomic_clear_mask);
	eval 'sub atomic_set_mask {
	    my($mask,$v) = @_;
    	    eval q({  &__CS_LOOP($v, $mask, \\"or\\"); });
	}' unless defined(&atomic_set_mask);
	eval 'sub atomic_xchg {
	    my($v, $new) = @_;
    	    eval q(( &xchg((($v)-> &counter), $new)));
	}' unless defined(&atomic_xchg);
	eval 'sub atomic_cmpxchg {
	    my($v,$old,$new) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&atomic_cmpxchg);
	eval 'sub atomic_add_unless {
	    my($v,$a,$u) = @_;
    	    eval q({ \'int\'  &c,  &old;  &c =  &atomic_read($v);  &for (;;) {  &if ( &unlikely( &c == $u))  &break;  &old =  &atomic_cmpxchg($v,  &c,  &c + $a);  &if ( &likely( &old ==  &c))  &break;  &c =  &old; }  &c != $u; });
	}' unless defined(&atomic_add_unless);
	eval 'sub atomic_inc_not_zero {
	    my($v) = @_;
    	    eval q( &atomic_add_unless(($v), 1, 0));
	}' unless defined(&atomic_inc_not_zero);
	undef(&__CS_LOOP) if defined(&__CS_LOOP);
	if(defined(&__s390x__)) {
	    eval 'sub ATOMIC64_INIT {
	        my($i) = @_;
    		eval q({ ($i) });
	    }' unless defined(&ATOMIC64_INIT);
	    eval 'sub __CSG_LOOP {
	        my($ptr, $op_val, $op_string) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&__CSG_LOOP);
	    eval 'sub atomic64_read {
	        my($v) = @_;
    		eval q((($v)-> &counter));
	    }' unless defined(&atomic64_read);
	    eval 'sub atomic64_set {
	        my($v,$i) = @_;
    		eval q(((($v)-> &counter) = ($i)));
	    }' unless defined(&atomic64_set);
	    eval 'sub atomic64_add_return {
	        my($i,$v) = @_;
    		eval q({  &__CSG_LOOP($v, $i, \\"agr\\"); });
	    }' unless defined(&atomic64_add_return);
	    eval 'sub atomic64_add {
	        my($_i, $_v) = @_;
    		eval q( &atomic64_add_return($_i, $_v));
	    }' unless defined(&atomic64_add);
	    eval 'sub atomic64_add_negative {
	        my($_i, $_v) = @_;
    		eval q(( &atomic64_add_return($_i, $_v) < 0));
	    }' unless defined(&atomic64_add_negative);
	    eval 'sub atomic64_inc {
	        my($_v) = @_;
    		eval q( &atomic64_add_return(1, $_v));
	    }' unless defined(&atomic64_inc);
	    eval 'sub atomic64_inc_return {
	        my($_v) = @_;
    		eval q( &atomic64_add_return(1, $_v));
	    }' unless defined(&atomic64_inc_return);
	    eval 'sub atomic64_inc_and_test {
	        my($_v) = @_;
    		eval q(( &atomic64_add_return(1, $_v) == 0));
	    }' unless defined(&atomic64_inc_and_test);
	    eval 'sub atomic64_sub_return {
	        my($i,$v) = @_;
    		eval q({  &__CSG_LOOP($v, $i, \\"sgr\\"); });
	    }' unless defined(&atomic64_sub_return);
	    eval 'sub atomic64_sub {
	        my($_i, $_v) = @_;
    		eval q( &atomic64_sub_return($_i, $_v));
	    }' unless defined(&atomic64_sub);
	    eval 'sub atomic64_sub_and_test {
	        my($_i, $_v) = @_;
    		eval q(( &atomic64_sub_return($_i, $_v) == 0));
	    }' unless defined(&atomic64_sub_and_test);
	    eval 'sub atomic64_dec {
	        my($_v) = @_;
    		eval q( &atomic64_sub_return(1, $_v));
	    }' unless defined(&atomic64_dec);
	    eval 'sub atomic64_dec_return {
	        my($_v) = @_;
    		eval q( &atomic64_sub_return(1, $_v));
	    }' unless defined(&atomic64_dec_return);
	    eval 'sub atomic64_dec_and_test {
	        my($_v) = @_;
    		eval q(( &atomic64_sub_return(1, $_v) == 0));
	    }' unless defined(&atomic64_dec_and_test);
	    eval 'sub atomic64_clear_mask {
	        my($mask,$v) = @_;
    		eval q({  &__CSG_LOOP($v, ~$mask, \\"ngr\\"); });
	    }' unless defined(&atomic64_clear_mask);
	    eval 'sub atomic64_set_mask {
	        my($mask,$v) = @_;
    		eval q({  &__CSG_LOOP($v, $mask, \\"ogr\\"); });
	    }' unless defined(&atomic64_set_mask);
	    eval 'sub atomic64_cmpxchg {
	        my($v,$old,$new) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&atomic64_cmpxchg);
	    eval 'sub atomic64_add_unless {
	        my($v,$a,$u) = @_;
    		eval q({ my $c,  &old;  $c =  &atomic64_read($v);  &for (;;) {  &if ( &unlikely( $c == $u))  &break;  &old =  &atomic64_cmpxchg($v,  $c,  $c + $a);  &if ( &likely( &old ==  $c))  &break;  $c =  &old; }  $c != $u; });
	    }' unless defined(&atomic64_add_unless);
	    eval 'sub atomic64_inc_not_zero {
	        my($v) = @_;
    		eval q( &atomic64_add_unless(($v), 1, 0));
	    }' unless defined(&atomic64_inc_not_zero);
	    undef(&__CSG_LOOP) if defined(&__CSG_LOOP);
	}
	eval 'sub smp_mb__before_atomic_dec () {
	    eval q( &smp_mb());
	}' unless defined(&smp_mb__before_atomic_dec);
	eval 'sub smp_mb__after_atomic_dec () {
	    eval q( &smp_mb());
	}' unless defined(&smp_mb__after_atomic_dec);
	eval 'sub smp_mb__before_atomic_inc () {
	    eval q( &smp_mb());
	}' unless defined(&smp_mb__before_atomic_inc);
	eval 'sub smp_mb__after_atomic_inc () {
	    eval q( &smp_mb());
	}' unless defined(&smp_mb__after_atomic_inc);
	require 'asm-generic/atomic.ph';
    }
}
1;
