require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_S390_BITOPS_H)) {
    eval 'sub _S390_BITOPS_H () {1;}' unless defined(&_S390_BITOPS_H);
    if(defined(&__KERNEL__)) {
	require 'linux/compiler.ph';
	unless(defined(&__s390x__)) {
	    eval 'sub __BITOPS_ALIGN () {3;}' unless defined(&__BITOPS_ALIGN);
	    eval 'sub __BITOPS_WORDSIZE () {32;}' unless defined(&__BITOPS_WORDSIZE);
	    eval 'sub __BITOPS_OR () {"or";}' unless defined(&__BITOPS_OR);
	    eval 'sub __BITOPS_AND () {"nr";}' unless defined(&__BITOPS_AND);
	    eval 'sub __BITOPS_XOR () {"xr";}' unless defined(&__BITOPS_XOR);
	    eval 'sub __BITOPS_LOOP {
	        my($__old, $__new, $__addr, $__val, $__op_string) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&__BITOPS_LOOP);
	} else {
	    eval 'sub __BITOPS_ALIGN () {7;}' unless defined(&__BITOPS_ALIGN);
	    eval 'sub __BITOPS_WORDSIZE () {64;}' unless defined(&__BITOPS_WORDSIZE);
	    eval 'sub __BITOPS_OR () {"ogr";}' unless defined(&__BITOPS_OR);
	    eval 'sub __BITOPS_AND () {"ngr";}' unless defined(&__BITOPS_AND);
	    eval 'sub __BITOPS_XOR () {"xgr";}' unless defined(&__BITOPS_XOR);
	    eval 'sub __BITOPS_LOOP {
	        my($__old, $__new, $__addr, $__val, $__op_string) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&__BITOPS_LOOP);
	}
	eval 'sub __BITOPS_WORDS {
	    my($bits) = @_;
    	    eval q(((($bits)+ &__BITOPS_WORDSIZE-1)/ &__BITOPS_WORDSIZE));
	}' unless defined(&__BITOPS_WORDS);
	eval 'sub __BITOPS_BARRIER () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&__BITOPS_BARRIER);
	if(defined(&CONFIG_SMP)) {
	}
	eval 'sub __constant_set_bit {
	    my($nr,$ptr) = @_;
    	    eval q({ my $addr;  $addr = ( $ptr) + (($nr ^ ( &__BITOPS_WORDSIZE - 8)) >> 3);  &switch ($nr&7) {  &case 0:  &asm  &volatile (\\"oi 0(%1),0x01\\" : \\"=m\\" (*  $addr) : \\"a\\" , \\"m\\" (*  $addr) : \\"cc\\" );  &break;  &case 1:  &asm  &volatile (\\"oi 0(%1),0x02\\" : \\"=m\\" (*  $addr) : \\"a\\" , \\"m\\" (*  $addr) : \\"cc\\" );  &break;  &case 2:  &asm  &volatile (\\"oi 0(%1),0x04\\" : \\"=m\\" (*  $addr) : \\"a\\" , \\"m\\" (*  $addr) : \\"cc\\" );  &break;  &case 3:  &asm  &volatile (\\"oi 0(%1),0x08\\" : \\"=m\\" (*  $addr) : \\"a\\" , \\"m\\" (*  $addr) : \\"cc\\" );  &break;  &case 4:  &asm  &volatile (\\"oi 0(%1),0x10\\" : \\"=m\\" (*  $addr) : \\"a\\" , \\"m\\" (*  $addr) : \\"cc\\" );  &break;  &case 5:  &asm  &volatile (\\"oi 0(%1),0x20\\" : \\"=m\\" (*  $addr) : \\"a\\" , \\"m\\" (*  $addr) : \\"cc\\" );  &break;  &case 6:  &asm  &volatile (\\"oi 0(%1),0x40\\" : \\"=m\\" (*  $addr) : \\"a\\" , \\"m\\" (*  $addr) : \\"cc\\" );  &break;  &case 7:  &asm  &volatile (\\"oi 0(%1),0x80\\" : \\"=m\\" (*  $addr) : \\"a\\" , \\"m\\" (*  $addr) : \\"cc\\" );  &break; } });
	}' unless defined(&__constant_set_bit);
	eval 'sub set_bit_simple {
	    my($nr,$addr) = @_;
    	    eval q(( &__builtin_constant_p(($nr)) ?  &__constant_set_bit(($nr),($addr)) :  &__set_bit(($nr),($addr)) ));
	}' unless defined(&set_bit_simple);
	eval 'sub __constant_clear_bit {
	    my($nr,$ptr) = @_;
    	    eval q({ my $addr;  $addr = ( $ptr) + (($nr ^ ( &__BITOPS_WORDSIZE - 8)) >> 3);  &switch ($nr&7) {  &case 0:  &asm  &volatile (\\"ni 0(%1),0xFE\\" : \\"=m\\" (*  $addr) : \\"a\\" , \\"m\\" (*  $addr) : \\"cc\\" );  &break;  &case 1:  &asm  &volatile (\\"ni 0(%1),0xFD\\": \\"=m\\" (*  $addr) : \\"a\\" , \\"m\\" (*  $addr) : \\"cc\\" );  &break;  &case 2:  &asm  &volatile (\\"ni 0(%1),0xFB\\" : \\"=m\\" (*  $addr) : \\"a\\" , \\"m\\" (*  $addr) : \\"cc\\" );  &break;  &case 3:  &asm  &volatile (\\"ni 0(%1),0xF7\\" : \\"=m\\" (*  $addr) : \\"a\\" , \\"m\\" (*  $addr) : \\"cc\\" );  &break;  &case 4:  &asm  &volatile (\\"ni 0(%1),0xEF\\" : \\"=m\\" (*  $addr) : \\"a\\" , \\"m\\" (*  $addr) : \\"cc\\" );  &break;  &case 5:  &asm  &volatile (\\"ni 0(%1),0xDF\\" : \\"=m\\" (*  $addr) : \\"a\\" , \\"m\\" (*  $addr) : \\"cc\\" );  &break;  &case 6:  &asm  &volatile (\\"ni 0(%1),0xBF\\" : \\"=m\\" (*  $addr) : \\"a\\" , \\"m\\" (*  $addr) : \\"cc\\" );  &break;  &case 7:  &asm  &volatile (\\"ni 0(%1),0x7F\\" : \\"=m\\" (*  $addr) : \\"a\\" , \\"m\\" (*  $addr) : \\"cc\\" );  &break; } });
	}' unless defined(&__constant_clear_bit);
	eval 'sub clear_bit_simple {
	    my($nr,$addr) = @_;
    	    eval q(( &__builtin_constant_p(($nr)) ?  &__constant_clear_bit(($nr),($addr)) :  &__clear_bit(($nr),($addr)) ));
	}' unless defined(&clear_bit_simple);
	eval 'sub __constant_change_bit {
	    my($nr,$ptr) = @_;
    	    eval q({ my $addr;  $addr = ( $ptr) + (($nr ^ ( &__BITOPS_WORDSIZE - 8)) >> 3);  &switch ($nr&7) {  &case 0:  &asm  &volatile (\\"xi 0(%1),0x01\\" : \\"=m\\" (*  $addr) : \\"a\\" , \\"m\\" (*  $addr) : \\"cc\\" );  &break;  &case 1:  &asm  &volatile (\\"xi 0(%1),0x02\\" : \\"=m\\" (*  $addr) : \\"a\\" , \\"m\\" (*  $addr) : \\"cc\\" );  &break;  &case 2:  &asm  &volatile (\\"xi 0(%1),0x04\\" : \\"=m\\" (*  $addr) : \\"a\\" , \\"m\\" (*  $addr) : \\"cc\\" );  &break;  &case 3:  &asm  &volatile (\\"xi 0(%1),0x08\\" : \\"=m\\" (*  $addr) : \\"a\\" , \\"m\\" (*  $addr) : \\"cc\\" );  &break;  &case 4:  &asm  &volatile (\\"xi 0(%1),0x10\\" : \\"=m\\" (*  $addr) : \\"a\\" , \\"m\\" (*  $addr) : \\"cc\\" );  &break;  &case 5:  &asm  &volatile (\\"xi 0(%1),0x20\\" : \\"=m\\" (*  $addr) : \\"a\\" , \\"m\\" (*  $addr) : \\"cc\\" );  &break;  &case 6:  &asm  &volatile (\\"xi 0(%1),0x40\\" : \\"=m\\" (*  $addr) : \\"a\\" , \\"m\\" (*  $addr) : \\"cc\\" );  &break;  &case 7:  &asm  &volatile (\\"xi 0(%1),0x80\\" : \\"=m\\" (*  $addr) : \\"a\\" , \\"m\\" (*  $addr) : \\"cc\\" );  &break; } });
	}' unless defined(&__constant_change_bit);
	eval 'sub change_bit_simple {
	    my($nr,$addr) = @_;
    	    eval q(( &__builtin_constant_p(($nr)) ?  &__constant_change_bit(($nr),($addr)) :  &__change_bit(($nr),($addr)) ));
	}' unless defined(&change_bit_simple);
	eval 'sub __test_and_set_bit {
	    my($X,$Y) = @_;
    	    eval q( &test_and_set_bit_simple($X,$Y));
	}' unless defined(&__test_and_set_bit);
	eval 'sub __test_and_clear_bit {
	    my($X,$Y) = @_;
    	    eval q( &test_and_clear_bit_simple($X,$Y));
	}' unless defined(&__test_and_clear_bit);
	eval 'sub __test_and_change_bit {
	    my($X,$Y) = @_;
    	    eval q( &test_and_change_bit_simple($X,$Y));
	}' unless defined(&__test_and_change_bit);
	if(defined(&CONFIG_SMP)) {
	    eval 'sub set_bit () { &set_bit_cs;}' unless defined(&set_bit);
	    eval 'sub clear_bit () { &clear_bit_cs;}' unless defined(&clear_bit);
	    eval 'sub change_bit () { &change_bit_cs;}' unless defined(&change_bit);
	    eval 'sub test_and_set_bit () { &test_and_set_bit_cs;}' unless defined(&test_and_set_bit);
	    eval 'sub test_and_clear_bit () { &test_and_clear_bit_cs;}' unless defined(&test_and_clear_bit);
	    eval 'sub test_and_change_bit () { &test_and_change_bit_cs;}' unless defined(&test_and_change_bit);
	} else {
	    eval 'sub set_bit () { &set_bit_simple;}' unless defined(&set_bit);
	    eval 'sub clear_bit () { &clear_bit_simple;}' unless defined(&clear_bit);
	    eval 'sub change_bit () { &change_bit_simple;}' unless defined(&change_bit);
	    eval 'sub test_and_set_bit () { &test_and_set_bit_simple;}' unless defined(&test_and_set_bit);
	    eval 'sub test_and_clear_bit () { &test_and_clear_bit_simple;}' unless defined(&test_and_clear_bit);
	    eval 'sub test_and_change_bit () { &test_and_change_bit_simple;}' unless defined(&test_and_change_bit);
	}
	eval 'sub __constant_test_bit {
	    my($nr,$addr) = @_;
    	    eval q({ ((( &volatile \'char\' *) $addr) [($nr^( &__BITOPS_WORDSIZE-8))>>3] & (1<<($nr&7))) != 0; });
	}' unless defined(&__constant_test_bit);
	eval 'sub test_bit {
	    my($nr,$addr) = @_;
    	    eval q(( &__builtin_constant_p(($nr)) ?  &__constant_test_bit(($nr),($addr)) :  &__test_bit(($nr),($addr)) ));
	}' unless defined(&test_bit);
	if(defined(&__s390x__)) {
	}
	if(defined(&__s390x__)) {
	}
	unless(defined(&__s390x__)) {
	    eval 'sub find_first_zero_bit {
	        my($addr,$size) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&find_first_zero_bit);
	    eval 'sub find_first_bit {
	        my($addr,$size) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&find_first_bit);
	} else {
	    eval 'sub find_first_zero_bit {
	        my($addr,$size) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&find_first_zero_bit);
	    eval 'sub find_first_bit {
	        my($addr,$size) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&find_first_bit);
	}
	eval 'sub find_next_zero_bit {
	    my($addr,$size,$offset) = @_;
    	    eval q({  &const \'unsigned long\' * &p; my $bit,  &set;  &if ($offset >= $size) $size;  $bit = $offset & ( &__BITOPS_WORDSIZE - 1); $offset -=  $bit; $size -= $offset;  &p = $addr + $offset /  &__BITOPS_WORDSIZE;  &if ( $bit) {  &set =  &ffz(* &p >>  $bit) +  $bit;  &if ( &set >= $size) $size + $offset;  &if ( &set <  &__BITOPS_WORDSIZE)  &set + $offset; $offset +=  &__BITOPS_WORDSIZE; $size -=  &__BITOPS_WORDSIZE;  &p++; } $offset +  &find_first_zero_bit( &p, $size); });
	}' unless defined(&find_next_zero_bit);
	eval 'sub find_next_bit {
	    my($addr,$size,$offset) = @_;
    	    eval q({  &const \'unsigned long\' * &p; my $bit,  &set;  &if ($offset >= $size) $size;  $bit = $offset & ( &__BITOPS_WORDSIZE - 1); $offset -=  $bit; $size -= $offset;  &p = $addr + $offset /  &__BITOPS_WORDSIZE;  &if ( $bit) {  &set =  &__ffs(* &p & (~0 <<  $bit));  &if ( &set >= $size) $size + $offset;  &if ( &set <  &__BITOPS_WORDSIZE)  &set + $offset; $offset +=  &__BITOPS_WORDSIZE; $size -=  &__BITOPS_WORDSIZE;  &p++; } $offset +  &find_first_bit( &p, $size); });
	}' unless defined(&find_next_bit);
	require 'asm-generic/bitops/ffs.ph';
	require 'asm-generic/bitops/fls.ph';
	require 'asm-generic/bitops/fls64.ph';
	require 'asm-generic/bitops/hweight.ph';
	eval 'sub ext2_set_bit {
	    my($nr, $addr) = @_;
    	    eval q( &__test_and_set_bit(($nr)^( &__BITOPS_WORDSIZE - 8), $addr));
	}' unless defined(&ext2_set_bit);
	eval 'sub ext2_set_bit_atomic {
	    my($lock, $nr, $addr) = @_;
    	    eval q( &test_and_set_bit(($nr)^( &__BITOPS_WORDSIZE - 8), $addr));
	}' unless defined(&ext2_set_bit_atomic);
	eval 'sub ext2_clear_bit {
	    my($nr, $addr) = @_;
    	    eval q( &__test_and_clear_bit(($nr)^( &__BITOPS_WORDSIZE - 8), $addr));
	}' unless defined(&ext2_clear_bit);
	eval 'sub ext2_clear_bit_atomic {
	    my($lock, $nr, $addr) = @_;
    	    eval q( &test_and_clear_bit(($nr)^( &__BITOPS_WORDSIZE - 8), $addr));
	}' unless defined(&ext2_clear_bit_atomic);
	eval 'sub ext2_test_bit {
	    my($nr, $addr) = @_;
    	    eval q( &test_bit(($nr)^( &__BITOPS_WORDSIZE - 8), $addr));
	}' unless defined(&ext2_test_bit);
	unless(defined(&__s390x__)) {
	    eval 'sub ext2_find_first_zero_bit {
	        my($vaddr,$size) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&ext2_find_first_zero_bit);
	} else {
	    eval 'sub ext2_find_first_zero_bit {
	        my($vaddr,$size) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&ext2_find_first_zero_bit);
	}
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub ext2_find_next_zero_bit {
	    my($vaddr,$size,$offset) = @_;
    	    eval q({ \'unsigned long\' * &addr = $vaddr, * &p; my $word,  &bit,  &set;  &if ($offset >= $size) $size;  &bit = $offset & ( &__BITOPS_WORDSIZE - 1); $offset -=  &bit; $size -= $offset;  &p =  &addr + $offset /  &__BITOPS_WORDSIZE;  &if ( &bit) {  &set =  &ffz( $word >>  &bit) +  &bit;  &if ( &set >= $size) $size + $offset;  &if ( &set <  &__BITOPS_WORDSIZE)  &set + $offset; $offset +=  &__BITOPS_WORDSIZE; $size -=  &__BITOPS_WORDSIZE;  &p++; } $offset +  &ext2_find_first_zero_bit( &p, $size); });
	}' unless defined(&ext2_find_next_zero_bit);
	require 'asm-generic/bitops/minix.ph';
    }
}
1;
