require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_S390_PAGE_H)) {
    eval 'sub _S390_PAGE_H () {1;}' unless defined(&_S390_PAGE_H);
    require 'asm/types.ph';
    eval 'sub PAGE_SHIFT () {12;}' unless defined(&PAGE_SHIFT);
    eval 'sub PAGE_SIZE () {(1 <<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
    eval 'sub PAGE_MASK () {(~( &PAGE_SIZE-1));}' unless defined(&PAGE_MASK);
    eval 'sub PAGE_DEFAULT_ACC () {0;}' unless defined(&PAGE_DEFAULT_ACC);
    eval 'sub PAGE_DEFAULT_KEY () {( &PAGE_DEFAULT_ACC << 4);}' unless defined(&PAGE_DEFAULT_KEY);
    if(defined(&__KERNEL__)) {
	require 'asm/setup.ph';
	unless(defined(&__ASSEMBLY__)) {
	    unless(defined(&__s390x__)) {
		eval 'sub clear_page {
		    my($page) = @_;
    		    eval q({  &register_pair  &rp;  ($rp->{subreg}->{even}) =  $page;  ($rp->{subreg}->{odd}) =  4096;  &asm  &volatile (\\"   slr  1,1\\\\n\\" \\"   mvcl %0,0\\" : \\"+&a\\" ( &rp) : : \\"memory\\", \\"cc\\", \\"1\\" ); });
		}' unless defined(&clear_page);
		eval 'sub copy_page {
		    my($to,$from) = @_;
    		    eval q({  &if ( &MACHINE_HAS_MVPG)  &asm  &volatile (\\"   sr   0,0\\\\n\\" \\"   mvpg %0,%1\\" : : \\"a\\" (( &void *)($to)), \\"a\\" (( &void *)($from)) : \\"memory\\", \\"cc\\", \\"0\\" );  &else  &asm  &volatile (\\"   mvc  0(256,%0),0(%1)\\\\n\\" \\"   mvc  256(256,%0),256(%1)\\\\n\\" \\"   mvc  512(256,%0),512(%1)\\\\n\\" \\"   mvc  768(256,%0),768(%1)\\\\n\\" \\"   mvc  1024(256,%0),1024(%1)\\\\n\\" \\"   mvc  1280(256,%0),1280(%1)\\\\n\\" \\"   mvc  1536(256,%0),1536(%1)\\\\n\\" \\"   mvc  1792(256,%0),1792(%1)\\\\n\\" \\"   mvc  2048(256,%0),2048(%1)\\\\n\\" \\"   mvc  2304(256,%0),2304(%1)\\\\n\\" \\"   mvc  2560(256,%0),2560(%1)\\\\n\\" \\"   mvc  2816(256,%0),2816(%1)\\\\n\\" \\"   mvc  3072(256,%0),3072(%1)\\\\n\\" \\"   mvc  3328(256,%0),3328(%1)\\\\n\\" \\"   mvc  3584(256,%0),3584(%1)\\\\n\\" \\"   mvc  3840(256,%0),3840(%1)\\\\n\\" : : \\"a\\"(( &void *)($to)),\\"a\\"(( &void *)($from)) : \\"memory\\" ); });
		}' unless defined(&copy_page);
	    } else {
		eval 'sub clear_page {
		    my($page) = @_;
    		    eval q({  &asm  &volatile (\\"   lgr  2,%0\\\\n\\" \\"   lghi 3,4096\\\\n\\" \\"   slgr 1,1\\\\n\\" \\"   mvcl 2,0\\" : : \\"a\\" (( &void *) ($page)) : \\"memory\\", \\"cc\\", \\"1\\", \\"2\\", \\"3\\" ); });
		}' unless defined(&clear_page);
		eval 'sub copy_page {
		    my($to,$from) = @_;
    		    eval q({  &if ( &MACHINE_HAS_MVPG)  &asm  &volatile (\\"   sgr  0,0\\\\n\\" \\"   mvpg %0,%1\\" : : \\"a\\" (( &void *)($to)), \\"a\\" (( &void *)($from)) : \\"memory\\", \\"cc\\", \\"0\\" );  &else  &asm  &volatile (\\"   mvc  0(256,%0),0(%1)\\\\n\\" \\"   mvc  256(256,%0),256(%1)\\\\n\\" \\"   mvc  512(256,%0),512(%1)\\\\n\\" \\"   mvc  768(256,%0),768(%1)\\\\n\\" \\"   mvc  1024(256,%0),1024(%1)\\\\n\\" \\"   mvc  1280(256,%0),1280(%1)\\\\n\\" \\"   mvc  1536(256,%0),1536(%1)\\\\n\\" \\"   mvc  1792(256,%0),1792(%1)\\\\n\\" \\"   mvc  2048(256,%0),2048(%1)\\\\n\\" \\"   mvc  2304(256,%0),2304(%1)\\\\n\\" \\"   mvc  2560(256,%0),2560(%1)\\\\n\\" \\"   mvc  2816(256,%0),2816(%1)\\\\n\\" \\"   mvc  3072(256,%0),3072(%1)\\\\n\\" \\"   mvc  3328(256,%0),3328(%1)\\\\n\\" \\"   mvc  3584(256,%0),3584(%1)\\\\n\\" \\"   mvc  3840(256,%0),3840(%1)\\\\n\\" : : \\"a\\"(( &void *)($to)),\\"a\\"(( &void *)($from)) : \\"memory\\" ); });
		}' unless defined(&copy_page);
	    }
	    eval 'sub clear_user_page {
	        my($page, $vaddr, $pg) = @_;
    		eval q( &clear_page($page));
	    }' unless defined(&clear_user_page);
	    eval 'sub copy_user_page {
	        my($to, $from, $vaddr, $pg) = @_;
    		eval q( &copy_page($to, $from));
	    }' unless defined(&copy_user_page);
	    eval 'sub alloc_zeroed_user_highpage {
	        my($vma, $vaddr) = @_;
    		eval q( &alloc_page_vma( &GFP_HIGHUSER |  &__GFP_ZERO, $vma, $vaddr));
	    }' unless defined(&alloc_zeroed_user_highpage);
	    eval 'sub __HAVE_ARCH_ALLOC_ZEROED_USER_HIGHPAGE () {1;}' unless defined(&__HAVE_ARCH_ALLOC_ZEROED_USER_HIGHPAGE);
	    eval 'sub pte_val {
	        my($x) = @_;
    		eval q((($x). &pte));
	    }' unless defined(&pte_val);
	    eval 'sub pgprot_val {
	        my($x) = @_;
    		eval q((($x). &pgprot));
	    }' unless defined(&pgprot_val);
	    unless(defined(&__s390x__)) {
		eval 'sub pmd_val {
		    my($x) = @_;
    		    eval q((($x). &pmd));
		}' unless defined(&pmd_val);
		eval 'sub pgd_val {
		    my($x) = @_;
    		    eval q((($x). &pgd0));
		}' unless defined(&pgd_val);
	    } else {
		eval 'sub pmd_val {
		    my($x) = @_;
    		    eval q((($x). &pmd0));
		}' unless defined(&pmd_val);
		eval 'sub pmd_val1 {
		    my($x) = @_;
    		    eval q((($x). &pmd1));
		}' unless defined(&pmd_val1);
		eval 'sub pgd_val {
		    my($x) = @_;
    		    eval q((($x). &pgd));
		}' unless defined(&pgd_val);
	    }
	    eval 'sub __pte {
	        my($x) = @_;
    		eval q((( &pte_t) { ($x) } ));
	    }' unless defined(&__pte);
	    eval 'sub __pmd {
	        my($x) = @_;
    		eval q((( &pmd_t) { ($x) } ));
	    }' unless defined(&__pmd);
	    eval 'sub __pgd {
	        my($x) = @_;
    		eval q((( &pgd_t) { ($x) } ));
	    }' unless defined(&__pgd);
	    eval 'sub __pgprot {
	        my($x) = @_;
    		eval q((( &pgprot_t) { ($x) } ));
	    }' unless defined(&__pgprot);
	    eval 'sub page_set_storage_key {
	        my($addr,$skey) = @_;
    		eval q({  &asm  &volatile ( \\"sske %0,%1\\" : : \\"d\\" ($skey), \\"a\\" ($addr) ); });
	    }' unless defined(&page_set_storage_key);
	    eval 'sub page_get_storage_key {
	        my($addr) = @_;
    		eval q({ my $skey;  &asm  &volatile ( \\"iske %0,%1\\" : \\"=d\\" ( $skey) : \\"a\\" ($addr), \\"0\\" (0) );  $skey; });
	    }' unless defined(&page_get_storage_key);
	}
	eval 'sub PAGE_ALIGN {
	    my($addr) = @_;
    	    eval q(((($addr)+ &PAGE_SIZE-1) &PAGE_MASK));
	}' unless defined(&PAGE_ALIGN);
	eval 'sub __PAGE_OFFSET () {0x;}' unless defined(&__PAGE_OFFSET);
	eval 'sub PAGE_OFFSET () {0x;}' unless defined(&PAGE_OFFSET);
	eval 'sub __pa {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&__pa);
	eval 'sub __va {
	    my($x) = @_;
    	    eval q(( &void *)($x));
	}' unless defined(&__va);
	eval 'sub virt_to_page {
	    my($kaddr) = @_;
    	    eval q( &pfn_to_page( &__pa($kaddr) >>  &PAGE_SHIFT));
	}' unless defined(&virt_to_page);
	eval 'sub pfn_valid {
	    my($pfn) = @_;
    	    eval q((($pfn) <  &max_mapnr));
	}' unless defined(&pfn_valid);
	eval 'sub virt_addr_valid {
	    my($kaddr) = @_;
    	    eval q( &pfn_valid( &__pa($kaddr) >>  &PAGE_SHIFT));
	}' unless defined(&virt_addr_valid);
	eval 'sub VM_DATA_DEFAULT_FLAGS () {( &VM_READ |  &VM_WRITE |  &VM_EXEC |  &VM_MAYREAD |  &VM_MAYWRITE |  &VM_MAYEXEC);}' unless defined(&VM_DATA_DEFAULT_FLAGS);
	require 'asm-generic/memory_model.ph';
	require 'asm-generic/page.ph';
    }
}
1;
