require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SYSTEM_H)) {
    eval 'sub __ASM_SYSTEM_H () {1;}' unless defined(&__ASM_SYSTEM_H);
    require 'linux/kernel.ph';
    require 'asm/types.ph';
    require 'asm/ptrace.ph';
    require 'asm/setup.ph';
    require 'asm/processor.ph';
    if(defined(&__KERNEL__)) {
	if(defined(&__s390x__)) {
	    eval 'sub __FLAG_SHIFT () {56;}' unless defined(&__FLAG_SHIFT);
	} else {
	    eval 'sub __FLAG_SHIFT () {24;}' unless defined(&__FLAG_SHIFT);
	}
	eval 'sub save_fp_regs {
	    my($fpregs) = @_;
    	    eval q({  &asm  &volatile ( \\"   std   0,8(%1)\\\\n\\" \\"   std   2,24(%1)\\\\n\\" \\"   std   4,40(%1)\\\\n\\" \\"   std   6,56(%1)\\" : \\"=m\\" (*$fpregs) : \\"a\\" ($fpregs), \\"m\\" (*$fpregs) : \\"memory\\" );  &if (! &MACHINE_HAS_IEEE) ;  &asm  &volatile( \\"   stfpc 0(%1)\\\\n\\" \\"   std   1,16(%1)\\\\n\\" \\"   std   3,32(%1)\\\\n\\" \\"   std   5,48(%1)\\\\n\\" \\"   std   7,64(%1)\\\\n\\" \\"   std   8,72(%1)\\\\n\\" \\"   std   9,80(%1)\\\\n\\" \\"   std   10,88(%1)\\\\n\\" \\"   std   11,96(%1)\\\\n\\" \\"   std   12,104(%1)\\\\n\\" \\"   std   13,112(%1)\\\\n\\" \\"   std   14,120(%1)\\\\n\\" \\"   std   15,128(%1)\\\\n\\" : \\"=m\\" (*$fpregs) : \\"a\\" ($fpregs), \\"m\\" (*$fpregs) : \\"memory\\" ); });
	}' unless defined(&save_fp_regs);
	eval 'sub restore_fp_regs {
	    my($fpregs) = @_;
    	    eval q({  &asm  &volatile ( \\"   ld    0,8(%0)\\\\n\\" \\"   ld    2,24(%0)\\\\n\\" \\"   ld    4,40(%0)\\\\n\\" \\"   ld    6,56(%0)\\" : : \\"a\\" ($fpregs), \\"m\\" (*$fpregs) );  &if (! &MACHINE_HAS_IEEE) ;  &asm  &volatile( \\"   lfpc  0(%0)\\\\n\\" \\"   ld    1,16(%0)\\\\n\\" \\"   ld    3,32(%0)\\\\n\\" \\"   ld    5,48(%0)\\\\n\\" \\"   ld    7,64(%0)\\\\n\\" \\"   ld    8,72(%0)\\\\n\\" \\"   ld    9,80(%0)\\\\n\\" \\"   ld    10,88(%0)\\\\n\\" \\"   ld    11,96(%0)\\\\n\\" \\"   ld    12,104(%0)\\\\n\\" \\"   ld    13,112(%0)\\\\n\\" \\"   ld    14,120(%0)\\\\n\\" \\"   ld    15,128(%0)\\\\n\\" : : \\"a\\" ($fpregs), \\"m\\" (*$fpregs) ); });
	}' unless defined(&restore_fp_regs);
	eval 'sub save_access_regs {
	    my($acrs) = @_;
    	    eval q({  &asm  &volatile (\\"stam 0,15,0(%0)\\" : : \\"a\\" ($acrs) : \\"memory\\" ); });
	}' unless defined(&save_access_regs);
	eval 'sub restore_access_regs {
	    my($acrs) = @_;
    	    eval q({  &asm  &volatile (\\"lam 0,15,0(%0)\\" : : \\"a\\" ($acrs) ); });
	}' unless defined(&restore_access_regs);
	eval 'sub switch_to {
	    my($prev,$next,$last) = @_;
    	    eval q( &do {  &if ($prev == $next)  &break;  &save_fp_regs( ($prev->{thread}->{fp_regs}));  &restore_fp_regs( ($next->{thread}->{fp_regs}));  &save_access_regs( ($prev->{thread}->{acrs[0]}));  &restore_access_regs( ($next->{thread}->{acrs[0]})); $prev =  &__switch_to($prev,$next); }  &while (0));
	}' unless defined(&switch_to);
	if(defined(&CONFIG_VIRT_CPU_ACCOUNTING)) {
	} else {
	    eval 'sub account_vtime {
	        my($x) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&account_vtime);
	}
	eval 'sub finish_arch_switch {
	    my($prev) = @_;
    	    eval q( &do {  &set_fs( ($current->{thread}->{mm_segment}));  &account_vtime($prev); }  &while (0));
	}' unless defined(&finish_arch_switch);
	eval 'sub nop () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&nop);
	eval 'sub xchg {
	    my($ptr,$x) = @_;
    	    eval q(({  &__typeof__(*($ptr))  &__ret;  &__ret = ( &__typeof__(*($ptr)))  &__xchg(($x), ( &void *)($ptr),$sizeof{($ptr)});  &__ret; }));
	}' unless defined(&xchg);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __xchg {
	    my($x,$ptr,$size) = @_;
    	    eval q({ my $addr,  &old; \'int\'  &shift;  &switch ($size) {  &case 1:  $addr =  $ptr;  &shift = (3^ ( $addr & 3)) << 3;  $addr ^=  $addr & 3;  &asm  &volatile( \\"    l   %0,0(%4)\\\\n\\" \\"0:  lr  0,%0\\\\n\\" \\"    nr  0,%3\\\\n\\" \\"    or  0,%2\\\\n\\" \\"    cs  %0,0,0(%4)\\\\n\\" \\"    jl  0b\\\\n\\" : \\"=&d\\" , \\"=m\\" (*  $addr) : \\"d\\" ($x <<  &shift), \\"d\\" (~(255<<  &shift)), \\"a\\" , \\"m\\" (*  $addr) : \\"memory\\", \\"cc\\", \\"0\\" ); $x =  &old >>  &shift;  &break;  &case 2:  $addr =  $ptr;  &shift = (2^ ( $addr & 2)) << 3;  $addr ^=  $addr & 2;  &asm  &volatile( \\"    l   %0,0(%4)\\\\n\\" \\"0:  lr  0,%0\\\\n\\" \\"    nr  0,%3\\\\n\\" \\"    or  0,%2\\\\n\\" \\"    cs  %0,0,0(%4)\\\\n\\" \\"    jl  0b\\\\n\\" : \\"=&d\\" , \\"=m\\" (*  $addr) : \\"d\\" ($x <<  &shift), \\"d\\" (~(65535<<  &shift)), \\"a\\" , \\"m\\" (*  $addr) : \\"memory\\", \\"cc\\", \\"0\\" ); $x =  &old >>  &shift;  &break;  &case 4:  &asm  &volatile ( \\"    l   %0,0(%3)\\\\n\\" \\"0:  cs  %0,%2,0(%3)\\\\n\\" \\"    jl  0b\\\\n\\" : \\"=&d\\" , \\"=m\\" (* $ptr) : \\"d\\" , \\"a\\" , \\"m\\" (* $ptr) : \\"memory\\", \\"cc\\" ); $x =  &old;  &break; } $x; });
	}' unless defined(&__xchg);
	eval 'sub __HAVE_ARCH_CMPXCHG () {1;}' unless defined(&__HAVE_ARCH_CMPXCHG);
	eval 'sub cmpxchg {
	    my($ptr,$o,$n) = @_;
    	    eval q((( &__typeof__(*($ptr))) &__cmpxchg(($ptr),($o), ($n),$sizeof{($ptr)})));
	}' unless defined(&cmpxchg);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __cmpxchg {
	    my($ptr,$old,$new,$size) = @_;
    	    eval q({ my $addr,  &prev,  &tmp; \'int\'  &shift;  &switch ($size) {  &case 1:  $addr =  $ptr;  &shift = (3^ ( $addr & 3)) << 3;  $addr ^=  $addr & 3;  &asm  &volatile( \\"    l   %0,0(%4)\\\\n\\" \\"0:  nr  %0,%5\\\\n\\" \\"    lr  %1,%0\\\\n\\" \\"    or  %0,%2\\\\n\\" \\"    or  %1,%3\\\\n\\" \\"    cs  %0,%1,0(%4)\\\\n\\" \\"    jnl 1f\\\\n\\" \\"    xr  %1,%0\\\\n\\" \\"    nr  %1,%5\\\\n\\" \\"    jnz 0b\\\\n\\" \\"1:\\" : \\"=&d\\" ( &prev), \\"=&d\\" ( &tmp) : \\"d\\" ($old <<  &shift), \\"d\\" ($new <<  &shift), \\"a\\" ($ptr), \\"d\\" (~(255<<  &shift)) : \\"memory\\", \\"cc\\" );  &prev >>  &shift;  &case 2:  $addr =  $ptr;  &shift = (2^ ( $addr & 2)) << 3;  $addr ^=  $addr & 2;  &asm  &volatile( \\"    l   %0,0(%4)\\\\n\\" \\"0:  nr  %0,%5\\\\n\\" \\"    lr  %1,%0\\\\n\\" \\"    or  %0,%2\\\\n\\" \\"    or  %1,%3\\\\n\\" \\"    cs  %0,%1,0(%4)\\\\n\\" \\"    jnl 1f\\\\n\\" \\"    xr  %1,%0\\\\n\\" \\"    nr  %1,%5\\\\n\\" \\"    jnz 0b\\\\n\\" \\"1:\\" : \\"=&d\\" ( &prev), \\"=&d\\" ( &tmp) : \\"d\\" ($old <<  &shift), \\"d\\" ($new <<  &shift), \\"a\\" ($ptr), \\"d\\" (~(65535<<  &shift)) : \\"memory\\", \\"cc\\" );  &prev >>  &shift;  &case 4:  &asm  &volatile ( \\"    cs  %0,%2,0(%3)\\\\n\\" : \\"=&d\\" ( &prev) : \\"0\\" ($old), \\"d\\" ($new), \\"a\\" ($ptr) : \\"memory\\", \\"cc\\" );  &prev; } $old; });
	}' unless defined(&__cmpxchg);
	eval 'sub eieio () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&eieio);
	eval 'sub SYNC_OTHER_CORES {
	    my($x) = @_;
    	    eval q( &eieio());
	}' unless defined(&SYNC_OTHER_CORES);
	eval 'sub mb () {
	    eval q( &eieio());
	}' unless defined(&mb);
	eval 'sub rmb () {
	    eval q( &eieio());
	}' unless defined(&rmb);
	eval 'sub wmb () {
	    eval q( &eieio());
	}' unless defined(&wmb);
	eval 'sub read_barrier_depends () {
	    eval q( &do { }  &while(0));
	}' unless defined(&read_barrier_depends);
	eval 'sub smp_mb () {
	    eval q( &mb());
	}' unless defined(&smp_mb);
	eval 'sub smp_rmb () {
	    eval q( &rmb());
	}' unless defined(&smp_rmb);
	eval 'sub smp_wmb () {
	    eval q( &wmb());
	}' unless defined(&smp_wmb);
	eval 'sub smp_read_barrier_depends () {
	    eval q( &read_barrier_depends());
	}' unless defined(&smp_read_barrier_depends);
	eval 'sub smp_mb__before_clear_bit () {
	    eval q( &smp_mb());
	}' unless defined(&smp_mb__before_clear_bit);
	eval 'sub smp_mb__after_clear_bit () {
	    eval q( &smp_mb());
	}' unless defined(&smp_mb__after_clear_bit);
	eval 'sub set_mb {
	    my($var, $value) = @_;
    	    eval q( &do { $var = $value;  &mb(); }  &while (0));
	}' unless defined(&set_mb);
	if(defined(&__s390x__)) {
	    eval 'sub __ctl_load {
	        my($array, $low, $high) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&__ctl_load);
	    eval 'sub __ctl_store {
	        my($array, $low, $high) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&__ctl_store);
	    eval 'sub __ctl_set_bit {
	        my($cr, $bit) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&__ctl_set_bit);
	    eval 'sub __ctl_clear_bit {
	        my($cr, $bit) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&__ctl_clear_bit);
	} else {
	    eval 'sub __ctl_load {
	        my($array, $low, $high) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&__ctl_load);
	    eval 'sub __ctl_store {
	        my($array, $low, $high) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&__ctl_store);
	    eval 'sub __ctl_set_bit {
	        my($cr, $bit) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&__ctl_set_bit);
	    eval 'sub __ctl_clear_bit {
	        my($cr, $bit) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&__ctl_clear_bit);
	}
	require 'linux/irqflags.ph';
	eval 'sub local_mcck_enable () {
	    eval q( &__set_psw_mask( &PSW_KERNEL_BITS));
	}' unless defined(&local_mcck_enable);
	eval 'sub local_mcck_disable () {
	    eval q( &__set_psw_mask( &PSW_KERNEL_BITS & ~ &PSW_MASK_MCHECK));
	}' unless defined(&local_mcck_disable);
	if(defined(&CONFIG_SMP)) {
	    eval 'sub ctl_set_bit {
	        my($cr, $bit) = @_;
    		eval q( &smp_ctl_set_bit($cr, $bit));
	    }' unless defined(&ctl_set_bit);
	    eval 'sub ctl_clear_bit {
	        my($cr, $bit) = @_;
    		eval q( &smp_ctl_clear_bit($cr, $bit));
	    }' unless defined(&ctl_clear_bit);
	} else {
	    eval 'sub ctl_set_bit {
	        my($cr, $bit) = @_;
    		eval q( &__ctl_set_bit($cr, $bit));
	    }' unless defined(&ctl_set_bit);
	    eval 'sub ctl_clear_bit {
	        my($cr, $bit) = @_;
    		eval q( &__ctl_clear_bit($cr, $bit));
	    }' unless defined(&ctl_clear_bit);
	}
	eval 'sub arch_align_stack {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&arch_align_stack);
    }
}
1;
